//+------------------------------------------------------------------+
//|                                                    Equity_v5.mq4 |
//|                                         Copyright  2007, Xupypr |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Xupypr"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 OrangeRed
#property indicator_color2 DodgerBlue
#property indicator_color3 SlateGray
#property indicator_color4 ForestGreen
#property indicator_width1 2
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

extern bool Show_Balance=true;
extern bool Show_Equity=true;
extern bool Show_Margin=false;
extern bool Show_Free=false;

double Balance[],Equity[],Margin[],Free[];
int AN,Total,W;

int    oob[]; //   
int    oty[]; // 
double olo[]; // 
string osy[]; // 
double oop[]; //  
int    ocb[]; //   
double ocp[]; //  
double oco[]; // 
double osw[]; //  
double opr[]; // 
double csw[]; //  
double dsw[]; //  

string Currency,Shortname;
bool   First;

//+----------------------------------------------------------------------------+
//|  Custom indicator initialization function                                  |
//+----------------------------------------------------------------------------+
int init()
{
 First=true;
 AN=AccountNumber();
 SetIndexBuffer(0,Balance);
 SetIndexLabel(0,"Balance");
 SetIndexStyle(0,DRAW_LINE);
 SetIndexBuffer(1,Equity);
 SetIndexLabel(1,"Equity");
 SetIndexStyle(1,DRAW_LINE);
 SetIndexBuffer(2,Margin);
 SetIndexLabel(2,"Margin");
 SetIndexStyle(2,DRAW_LINE);
 SetIndexBuffer(3,Free);
 SetIndexLabel(3,"Free");
 SetIndexStyle(3,DRAW_LINE);
 Shortname="*";
 if (Show_Balance) Shortname=StringConcatenate(Shortname," Balance");
 if (Show_Equity)  Shortname=StringConcatenate(Shortname," Equity");
 if (Show_Margin)  Shortname=StringConcatenate(Shortname," Margin");
 if (Show_Free)    Shortname=StringConcatenate(Shortname," Free");
 IndicatorShortName(Shortname);
 IndicatorDigits(2);
 return(0);
}
//+----------------------------------------------------------------------------+
//|  Custom indicator deinitialization function                                |
//+----------------------------------------------------------------------------+
int deinit()
{
 ObjectsDeleteAll(W);
 return(0);
}
//+----------------------------------------------------------------------------+
//|  Custom indicator iteration function                                       |
//+----------------------------------------------------------------------------+
int start()
{
 W=WindowFind(Shortname);
 if (AN!=AccountNumber())
 {
  ArrayInitialize(Balance,EMPTY_VALUE);
  ArrayInitialize(Equity,EMPTY_VALUE);
  ArrayInitialize(Margin,EMPTY_VALUE);
  ArrayInitialize(Free,EMPTY_VALUE);
  ObjectsDeleteAll(W);
  AN=AccountNumber();
  First=true;
 }
 if (!First)
 {
  if (Show_Balance) Balance[0]=AccountBalance();
  if (Show_Equity)  Equity[0]=AccountEquity();
  if (Show_Margin)  Margin[0]=AccountMargin();
  if (Show_Free)    Free[0]=AccountFreeMargin();
  return(0);
 }
 if (!IsConnected())
 {
  Print("     ");
  return(0);
 }
 if (!OrderSelect(0,SELECT_BY_POS,MODE_HISTORY)) return(0);
 if (Period()>PERIOD_D1)
 {
  Alert("     D1"); 
  return(0);
 }
 First=false;
 
 datetime timebar;
 double b,e,s,t;
 string name,symbols;
 int bar,i,j;
 
 Currency=AccountCurrency();
 Total=OrdersHistoryTotal()+OrdersTotal();
 ArrayResize(oob,Total);
 ArrayResize(oty,Total);
 ArrayResize(olo,Total);
 ArrayResize(osy,Total);
 ArrayResize(oop,Total);
 ArrayResize(ocb,Total);
 ArrayResize(ocp,Total);
 ArrayResize(oco,Total);
 ArrayResize(osw,Total);
 ArrayResize(opr,Total);
 ArrayResize(csw,Total);
 ArrayResize(dsw,Total);
 Total=0;
 j=OrdersHistoryTotal();
 for (i=0;i<j;i++) if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) ReadDeals();
 j=OrdersTotal();
 for (i=0;i<j;i++) if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) ReadDeals();
 if (oty[0]<6)
 {
  Alert("    ");
  return(0);
 }
 ArrayResize(oob,Total);
 ArrayResize(oty,Total);
 ArrayResize(olo,Total);
 ArrayResize(osy,Total);
 ArrayResize(oop,Total);
 ArrayResize(ocb,Total);
 ArrayResize(ocp,Total);
 ArrayResize(oco,Total);
 ArrayResize(osw,Total);
 ArrayResize(opr,Total);
 ArrayResize(csw,Total);
 ArrayResize(dsw,Total);
 b=0;
 for (i=oob[0];i>=0;i--)
 {
  e=0;
  timebar=iTime(NULL,0,i);
  for (j=0;j<Total;j++)
  {
   if (ocb[j]==i && ocp[j]!=0) b+=osw[j]+oco[j]+opr[j];
   else if (oob[j]>=i && ocb[j]<=i)
   {
    if (oty[j]>5)
    {
     b+=opr[j];
     name=StringConcatenate("Time: ",TimeToStr(iTime(NULL,0,i)));
     if (ObjectFind(name)==-1) ObjectCreate(name,OBJ_VLINE,W,iTime(NULL,0,i),0);
     ObjectSetText(name,StringConcatenate(osy[j],": ",DoubleToStr(opr[j],2)));
     ObjectSet(name,OBJPROP_TIME1,iTime(NULL,0,i));
     ObjectSet(name,OBJPROP_COLOR,OrangeRed);
     ObjectSet(name,OBJPROP_WIDTH,2);
     continue;
    }
    if (MarketInfo(osy[j],MODE_POINT)==0)
    {
     if (StringFind(symbols,osy[j])==-1)
     {
      Alert("     "+osy[j]);
      symbols=StringConcatenate(symbols," ",osy[j]);
     }
     continue;
    }
    bar=iBarShift(osy[j],0,timebar);
    if (TimeDayOfWeek(iTime(osy[j],0,bar))!=TimeDayOfWeek(iTime(osy[j],0,bar+1)) && oob[j]!=bar)
    {
     switch (MarketInfo(osy[j],MODE_PROFITCALCMODE))
     {
      case 0:
      {
       if (TimeDayOfWeek(iTime(osy[j],0,bar))==4) csw[j]+=3*dsw[j];
       else csw[j]+=dsw[j];
      } break;
      case 1:
      {
       if (TimeDayOfWeek(iTime(osy[j],0,bar))==1) csw[j]+=3*dsw[j];
       else csw[j]+=dsw[j];
      }
     }
    }
    t=TickValue(osy[j],timebar);
    if (oty[j]==OP_BUY) e+=oco[j]+csw[j]+(iClose(osy[j],0,bar)-oop[j])*olo[j]*t;
    else
    {
     s=MarketInfo(osy[j],MODE_POINT)*MarketInfo(osy[j],MODE_SPREAD);
     e+=oco[j]+csw[j]+(oop[j]-iClose(osy[j],0,bar)-s)*olo[j]*t;
    }
   }
  }
  if (Show_Balance) Balance[i]=NormalizeDouble(b,2);
  if (Show_Equity) Equity[i]=NormalizeDouble(b+e,2);
 }
 return(0);
}
//+----------------------------------------------------------------------------+
//|                                                                |
//+----------------------------------------------------------------------------+
void ReadDeals()
{
 int b,swap;
 
 if (OrderType()<2 || OrderType()>5)
 {
  oob[Total]=iBarShift(NULL,0,OrderOpenTime());
  oty[Total]=OrderType();
  olo[Total]=OrderLots();
  if (OrderType()>5) osy[Total]=OrderComment();
  else
  osy[Total]=OrderSymbol();
  oop[Total]=OrderOpenPrice();
  if (OrderCloseTime()!=0)
  {
   ocb[Total]=iBarShift(NULL,0,OrderCloseTime());
   ocp[Total]=OrderClosePrice();
  }
  else
  {
   ocb[Total]=0;
   ocp[Total]=0;
  }
  oco[Total]=OrderCommission();
  osw[Total]=OrderSwap();
  opr[Total]=OrderProfit();
  csw[Total]=0;
  swap=0;
  for (b=oob[Total]-1;b>=ocb[Total];b--)
  {
   if (TimeDayOfWeek(iTime(NULL,0,b))!=TimeDayOfWeek(iTime(NULL,0,b+1)))
   {
    if (TimeDayOfWeek(iTime(NULL,0,b))==4) swap+=3;
    else swap++;
   }
  }
  if (swap>0) dsw[Total]=osw[Total]/swap;
  Total++;
 }
}
//+----------------------------------------------------------------------------+
//|                                                  |
//+----------------------------------------------------------------------------+
double TickValue(string symbol, datetime tbar)
{
 double size;
 string usd="USD";
 switch (MarketInfo(symbol,MODE_PROFITCALCMODE))
 {
  case 0:
  {
   int sbar=iBarShift(symbol,0,tbar);
   size=MarketInfo(symbol,MODE_LOTSIZE);
   if (StringSubstr(symbol,3,3)==usd) break;
   if (StringSubstr(symbol,0,3)==usd) size=size/iClose(symbol,0,sbar);
   else
   {
    string BQ=StringSubstr(symbol,0,3)+usd;
    if (iClose(BQ,0,0)==0) BQ=usd+StringSubstr(symbol,0,3);
    if (iClose(BQ,0,0)==0) break;
    int bqbar=iBarShift(BQ,0,tbar);
    if (StringSubstr(BQ,0,3)==usd) size=size/iClose(BQ,0,bqbar)/iClose(symbol,0,sbar);
    else size=size*iClose(BQ,0,bqbar)/iClose(symbol,0,sbar);
   }
  } break;
  case 1:
  {
   size=MarketInfo(symbol,MODE_LOTSIZE);
  } break;
  case 2:
  {
   size=MarketInfo(symbol,MODE_TICKVALUE)/MarketInfo(symbol,MODE_TICKSIZE);
  }
 }
 if (Currency!="USD")
 {
  BQ=Currency+usd;
  if (iClose(BQ,0,0)==0)
  {
   BQ=usd+Currency;
   size*=iClose(BQ,0,iBarShift(BQ,0,tbar));
  }
  else size/=iClose(BQ,0,iBarShift(BQ,0,tbar));
 } 
 return(size);
}
//+----------------------------------------------------------------------------+